
/* 
 * name: getif_ip.c
 * this file is part of the "Net-Injector" project. It defines the getif_ip_by_name() function
 * Copyright (C) 2002 by Jean Philippe GUILLEMIN <jp.guillemin@free.fr>
 * license: This software is under GPL license
 * date: 04 17 2003
 * rev: 0.8
*/ 

#include "neti.h"


int getif_ip_by_name(char *ip, u_int32_t *inet_ip, char *ifname){
	
	struct ifreq ifr;
	struct sockaddr_in *addr;
	int sock;

	addr = (struct sockaddr_in *) &ifr.ifr_addr;
	memset(&ifr, 0, IFREQ_SIZE);

	if ((sock = socket(AF_INET, SOCK_STREAM, 0)) >= 0) {
		strncpy(ifr.ifr_name, ifname, 32);
		
		if (ioctl(sock, SIOCGIFADDR, &ifr) == 0){
			memcpy (inet_ip, &addr->sin_addr.s_addr, sizeof(addr->sin_addr.s_addr));
			strncpy(ip, inet_ntoa(addr->sin_addr), 32);
			/* fprintf(stdout, "%s\n", inet_ntoa(addr->sin_addr));  debug */
		}else{
			fprintf(stderr, "Error : (getif_ip) in call to ioctl() !\n");
			close(sock);
		}
	}else {
		fprintf(stderr, "Error : (getif_ip) cannot get src address !\n");
		return EXIT_FAILURE;
	}

	return EXIT_SUCCESS;
}
	
	
	
