
/* 
 * name: lookup.c
 * this file is part of the "Net-Injector" project. It defines the lookup() function
 * Copyright (C) 2002 by Jean Philippe GUILLEMIN <jp.guillemin@free.fr>
 * license: This software is under GPL license
 * date: 04 17 2003
 * rev: 0.8
*/ 

#include "neti.h"



int lookup(u_int32_t *inet_ip, char *ip, char *name) {
	
	struct hostent *hostnt;
	struct in_addr ip_addr;
	hostnt = malloc(HOSTENT_SIZE);
	  
	/* call gethostbyname() returns a pointer to a hostent struct or NULL.   */
	hostnt = gethostbyname(name);
	if (!hostnt) {
    	fprintf(stderr, "Error : %s was not resolved !\n",name);
    	exit(EXIT_FAILURE);
	}


	ip_addr = *(struct in_addr *)(hostnt->h_addr);
	*inet_ip = ip_addr.s_addr;
	strncpy(ip,inet_ntoa(ip_addr), 32);	
		
	/*fprintf(stdout,"%s resolved to %s\n",name, myhdr->dst_ip);*/
	return EXIT_SUCCESS;
}



int reverse_lookup(char *name, char *ip) {
	struct hostent *hostnt;
	struct in_addr ip_addr;
	hostnt = malloc(HOSTENT_SIZE);

	if (strncmp (last_address, ip, 32) == 0) {
		strncpy(name, last_name, 1024);
		return EXIT_SUCCESS;
	}
	
	/* call to gethostbyaddr() returns a pointer to a hostent struct or NULL.   */
	inet_aton(ip, &ip_addr);
	hostnt = gethostbyaddr((char*)&ip_addr, 4, AF_INET);
	if (!hostnt) {
		strncpy(name, ip, 1024);
	}else{
		strncpy(name, hostnt->h_name, 1024);
	}
	
	strncpy(last_name, name, 1024);
	strncpy(last_address, ip, 32);
	return EXIT_SUCCESS;
}
