
/* 
 * name: promisc.c
 * this file is part of the "Net-Injector" project. It defines the set_promisc() function
 * Copyright (C) 2002 by Jean Philippe GUILLEMIN <jp.guillemin@free.fr>
 * license: This software is under GPL license
 * date: 04 17 2003
 * rev: 0.8
*/ 

#include "neti.h"



int set_promisc(int sock) {
	
	struct ifreq ifr;
	memset(&ifr, 0, IFREQ_SIZE);
	strncpy(ifr.ifr_name, myhdr->interface, 32);
		
		if (ioctl(sock, SIOCGIFFLAGS, &ifr) == 0){
			ifr.ifr_flags |= IFF_PROMISC; 
			
			if (ioctl(sock, SIOCSIFFLAGS, &ifr) < 0){
				fprintf(stderr, "Error : cant set promiscuous mode !\n"); 
			}
		}else{
			fprintf(stderr, "Error : (set_promisc) in call to ioctl() !\n");
			return EXIT_FAILURE;
		}
	

return EXIT_SUCCESS;
}

int unset_promisc(int sock) {
	
	struct ifreq ifr;
	memset(&ifr, 0, IFREQ_SIZE);
	strncpy(ifr.ifr_name, myhdr->interface, 32);
		
		if (ioctl(sock, SIOCGIFFLAGS, &ifr) == 0){
			ifr.ifr_flags ^= IFF_PROMISC; 
			
			if (ioctl(sock, SIOCSIFFLAGS, &ifr) < 0){
				fprintf(stderr, "Erroro : cant unset promiscuous mode !\n"); 
			}
		}else{
			fprintf(stderr, "Error : (unset_promisc) in call to ioctl() !\n");
			return EXIT_FAILURE;
		}
	

return EXIT_SUCCESS;
}
