
/* 
 * name: utils.c
 * this file is part of the "Net-Injector" project. It defines small usefull functions
 * Copyright (C) 2002 by Jean Philippe GUILLEMIN <jp.guillemin@free.fr>
 * license: This software is under GPL license
 * date: 04 17 2003
 * rev: 0.8
*/ 

#include "neti.h"


/****************************/
/*   trap SIGINT            */
/****************************/


void catch_sig(int sig){
	fprintf(stdout, "Neti stoped by user - goodby...\n");
	if (be_promiscuous == 1) unset_promisc(*so_send);
		close(so_udp);
		close(so_tcp);
		close(so_icmp);
	exit(EXIT_SUCCESS);
}



/*****************************************/
/*  find the max socket id for select()  */
/*****************************************/

int max(int a, int b, int c) {
	if (b > a) a=b;
	if (c > a) a=c;
	return a;
}


/*****************************************/
/*			close sockets           	 */
/*****************************************/
 
void close_sockets(void){
	if (be_promiscuous == 1) unset_promisc(*so_send);
	close(so_udp);
	close(so_tcp);
	close(so_icmp);
	exit(EXIT_SUCCESS);
}



/*****************************************/
/*      calculate all checksums          */
/*****************************************/

u_int16_t sum(u_int16_t *buf, int nbytes){

	u_int32_t sum;
	u_int16_t byte;
	sum = 0;

	while (nbytes > 1) {
		sum += *buf++;
		nbytes -= 2;
	}
	if (nbytes == 1) {
		byte = 0;
		*((u_int16_t *) &byte) = *(unsigned char *) buf;
		sum += byte;
	}
	sum = (sum >> 16) + (sum & 0xffff);
	sum += (sum >> 16);


	return (u_int16_t) ~sum;

}	/* end sum */


/*****************************************/
/*      debug everywhere          		 */
/*****************************************/

int debug() {
	fprintf(stdout, "last_address = %s\n", last_address);
	fprintf(stdout, "last_name = %s\n", last_name);
	return EXIT_SUCCESS;
}



